from database import app
from flask_covid19.blueprints.app_all.all_config import BlueprintConfig
from flask_covid19.blueprints.data_ecdc.ecdc_model import EcdcDateReported, EcdcData


class EcdcTestService:
    def __init__(self, database, ecdc_service):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" ECDC Test Service [init]")
        app.logger.debug("------------------------------------------------------------")
        self.__database = database
        self.__ecdc_service = ecdc_service
        self.cfg = BlueprintConfig.create_config_for_ecdc()
        app.logger.debug("------------------------------------------------------------")
        app.logger.info(" ECDC Test Service [ready]")

    def delete_last_day(self):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" EcdcTestService.delete_last_day() [START]")
        app.logger.debug("------------------------------------------------------------")
        joungest_datum_str = EcdcData.get_joungest_datum()
        joungest_datum = EcdcDateReported.find_by_date_reported(joungest_datum_str)
        app.logger.info("joungest_datum:")
        app.logger.info(joungest_datum)
        app.logger.info("WhoData.get_data_for_one_day(joungest_datum):")
        i = 0
        for data in EcdcData.get_data_for_one_day(joungest_datum):
            i += 1
            line = " | " + str(i) + " | " + str(data.date_reported) + " | " + data.country.country + " | to be deleted"
            app.logger.info(line)
        app.logger.info("WhoData.delete_data_for_one_day(joungest_datum)")
        EcdcData.delete_data_for_one_day(joungest_datum)
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" EcdcTestService.delete_last_day() [DONE]")
        app.logger.debug("------------------------------------------------------------")

    def run_update_star_schema_incremental(self):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" EcdcTestService.run_update_star_schema_incremental() [START]")
        app.logger.debug("------------------------------------------------------------")
        self.__ecdc_service.update_star_schema()
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" EcdcTestService.run_update_star_schema_incremental() [DONE]")
        app.logger.debug("------------------------------------------------------------")
